using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using xnalab.ddo.jp.control;
using xnalab.ddo.jp.viewManager;
using xnalab.ddo.jp.util;
using GUISample.forms;
using GUISample.screens;

namespace GUISample
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Game
    {
        GraphicsDeviceManager graphics;
        ViewManager viewManager;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";

            graphics.PreferredBackBufferWidth = 640;
            graphics.PreferredBackBufferHeight = 480;

            viewManager = new ViewManager(this);
            Components.Add(viewManager);

            IsMouseVisible = true;
        }

        protected override void LoadContent()
        {
            LoginForm loginForm = new LoginForm("login");
            MainForm mainForm = new MainForm("main");
            MenuForm menuForm = new MenuForm("menu");
            viewManager.AddForm(loginForm);
            viewManager.AddForm(mainForm);
            viewManager.AddForm(menuForm);

            viewManager.AddScreen(new LoginScreen(loginForm));
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        protected override void Draw(GameTime gameTime)
        {
            graphics.GraphicsDevice.Clear(Color.CornflowerBlue);

            base.Draw(gameTime);
        }

        bool pushed;

        /// <summary>
        /// XV
        /// </summary>
        protected override void Update(GameTime gameTime)
        {
            KeyboardState keyState = Keyboard.GetState();

            // F1 ŃtXN[
            if (!pushed && keyState.IsKeyDown(Keys.F1))
            {
                graphics.ToggleFullScreen();
            }

            // ԋL
            pushed = keyState.IsKeyDown(Keys.F1);

            base.Update(gameTime);
        }
    }

    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        static void Main(string[] args)
        {
            using (Game1 game = new Game1())
            {
                game.Run();
            }
        }
    }
}

