using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using xnalab.ddo.jp.control;
using xnalab.ddo.jp.viewManager;
using xnalab.ddo.jp.util;
using GUISample.screens;

namespace GUISample.forms
{
    public class MainForm : BasicForm
    {
        int frame = 0;
        double ftime = 0;

        Color colorBack = new Color(0, 0, 0, 120);
        Color colorFrame = new Color(100, 100, 100, 255);

        // Rg[
        BasicLabel lblFPS;
        BasicLabel lblGuide;
        BasicButton btnOk;
        BasicButton btnClear;
        BasicButton btnMenu;
        BasicButton btnBack;
        BasicCheckBox checkBox1;
        RadioButtonGroup rdoGroup;
        BasicRadioButton rdo1;
        BasicRadioButton rdo2;
        BasicRadioButton rdo3;
        BasicTextBox textbox1;
        BasicListBox lstMessage;

        public MainForm(string name) : base(name)
        {
            // FPS\px
            lblFPS = new BasicLabel("lblFPS", "FPS: vZ...", new Vector2(10, 10), Color.White);

            // ʖ\px
            lblGuide = new BasicLabel("lblGuide", "MAIN FORM", new Vector2(10, 30), Color.White);

            // OK{^
            btnOk = new BasicButton("btnOk", "OK", new Rectangle(280, 450, 50, 20), 
                colorBack, Color.SkyBlue, colorFrame, Color.White);
            btnOk.MouseLeftDown += new MouseEventHandler(button_MouseDown);

            // Clear{^
            btnClear = new BasicButton("btnClear", "CLEAR", new Rectangle(340, 450, 50, 20), 
                colorBack, Color.SkyBlue, colorFrame, Color.White);
            btnClear.MouseLeftDown += new MouseEventHandler(btnClear_MouseDown);

            // Menu{^
            btnMenu = new BasicButton("btnMenu", "MENU", new Rectangle(520, 450, 50, 20),
                colorBack, Color.SkyBlue, colorFrame, Color.White);
            btnMenu.MouseLeftUp += new MouseEventHandler(btnMenu_MouseUp);

            // Back{^
            btnBack = new BasicButton("btnBack", "BACK", new Rectangle(580, 450, 50, 20),
                colorBack, Color.SkyBlue, colorFrame, Color.White);
            btnBack.MouseLeftUp += new MouseEventHandler(btnBack_MouseUp);

            // `FbN{bNX
            checkBox1 = new BasicCheckBox("check", "`FbN{bNX", 
                new Rectangle(300, 200, 12, 12), Color.SkyBlue, colorBack, colorFrame, Color.White);

            // WI{^
            rdoGroup = new RadioButtonGroup();
            rdo1 = new BasicRadioButton("rdo1", "WIP", 
                new Rectangle(300, 220, 12, 12), colorBack, Color.SkyBlue, colorFrame, Color.White);
            rdo2 = new BasicRadioButton("rdo2", "WIQ", 
                new Rectangle(300, 240, 12, 12), colorBack, Color.SkyBlue, colorFrame, Color.White);
            rdo3 = new BasicRadioButton("rdo3", "WIR", 
                new Rectangle(300, 260, 12, 12), colorBack, Color.SkyBlue, colorFrame, Color.White);
            rdoGroup.Add(rdo1);
            rdoGroup.Add(rdo2);
            rdoGroup.Add(rdo3);

            // bZ[WXg
            lstMessage = new BasicListBox("lstMessage", new Rectangle(20, 200, 250, 240), colorBack, colorFrame, Color.White);

            // eLXg{bNX
            textbox1 = new BasicTextBox("textbox1",
                new Rectangle(20, 450, 250, 20),
                colorBack, Color.Yellow, colorFrame, Color.White);

            // ǉԂŕ`悳
            // eLXg{bNX͕ϊ\肷̂łȂׂ
            // ̂قŒǉقǂ
            Add(lblFPS);
            Add(lblGuide);
            Add(btnOk);
            Add(btnClear);
            Add(btnMenu);
            Add(btnBack);
            Add(checkBox1);
            Add(rdoGroup);
            Add(lstMessage);
            Add(textbox1);
        }

        /// <summary>
        /// Reg̓ǂݍ
        /// </summary>
        public override void LoadContent()
        {
            ContentManager content = Manager.Game.Content;

            base.LoadContent();
        }

        /// <summary>
        /// XV
        /// </summary>
        public override void Update(GameTime gameTime)
        {
            ftime += gameTime.ElapsedGameTime.TotalSeconds;
            if (ftime > 1)
            {
                lblFPS.Text = String.Format("FPS: {0}", frame);
                ftime -= 1;
                frame = 0;
            }
            base.Update(gameTime);
        }

        /// <summary>
        /// `揈
        /// </summary>
        public override void Draw(GameTime gameTime)
        {
            frame++;

            base.Draw(gameTime);
        }

        /// <summary>
        /// L[Abv from BasicForm
        /// </summary>
        /// <param name="key"></param>
        public override void KeyUpHandle(Keys key)
        {
            if (key == Keys.Enter)
            {
                if (Manager.IsInputComplete && textbox1.Text.Length > 0)
                {
                    lstMessage.panel.Add(new Entry(textbox1.Text, Color.White));
                    textbox1.Text = string.Empty;
                }
            }

            base.KeyUpHandle(key);
        }

        /// <summary>
        /// {^_ECxg
        /// </summary>
        public void button_MouseDown(object sender, MouseEventArgs e)
        {
            if (textbox1.Text.Length == 0)
                return;

            lstMessage.panel.Add(new Entry(textbox1.Text, Color.White));
            textbox1.Text = string.Empty;
        }

        /// <summary>
        /// NA{^Cxg
        /// </summary>
        public void btnClear_MouseDown(object sender, MouseEventArgs e)
        {
            textbox1.Text = string.Empty;
            lstMessage.Clear();
        }

        /// <summary>
        /// j[{^Cxg
        /// </summary>
        public void btnMenu_MouseUp(object sender, MouseEventArgs e)
        {
            Manager.LockScreen();

            BasicForm form = Manager.GetForm("menu");
            Manager.AddScreen(new MenuScreen(form));
        }

        /// <summary>
        /// ߂{^Cxg
        /// </summary>
        public void btnBack_MouseUp(object sender, MouseEventArgs e)
        {
            BasicForm form = Manager.GetForm("login");
            Manager.ChangeScreen(new LoginScreen(form));
        }

    }
}
